# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Classes**

* [`linky_exporter`](#linky_exporter): This module manages linky Exporter
* [`linky_exporter::install`](#linky_exporterinstall): This class install linky exporter requirements and binaries.
* [`linky_exporter::service`](#linky_exporterservice): This class manages service

## Classes

### linky_exporter

Init class of linky Exporter module. It can installes linky Exporter binaries and single Service.

#### Examples

##### 

```puppet
include linky_exporter
```

#### Parameters

The following parameters are available in the `linky_exporter` class.

##### `version`

Data type: `String`

linky exporter release. See https://github.com/syberalexis/linky-exporter/releases

Default value: '1.0.0'

##### `os`

Data type: `String`

Operating system.

Default value: downcase($facts['kernel'])

##### `base_dir`

Data type: `Stdlib::Absolutepath`

Base directory where linky is extracted.

Default value: '/opt'

##### `bin_dir`

Data type: `Stdlib::Absolutepath`

Directory where binaries are located.

Default value: '/usr/local/bin'

##### `base_url`

Data type: `Stdlib::HTTPUrl`

Base URL for linky Exporter.

Default value: 'https://github.com/syberalexis/linky-exporter/releases/download'

##### `download_url`

Data type: `Optional[Stdlib::HTTPUrl]`

Complete URL corresponding to the linky exporter release, default to undef.

Default value: `undef`

##### `extract_command`

Data type: `Optional[String]`

Custom command passed to the archive resource to extract the downloaded archive.

Default value: `undef`

##### `manage_user`

Data type: `Boolean`

Whether to create user for linky_exporter or rely on external code for that.

Default value: `false`

##### `manage_group`

Data type: `Boolean`

Whether to create user for linky_exporter or rely on external code for that.

Default value: `false`

##### `user`

Data type: `String`

User running linky_exporter.

Default value: 'root'

##### `group`

Data type: `String`

Group under which linky_exporter is running.

Default value: 'root'

##### `user_shell`

Data type: `Stdlib::Absolutepath`

if requested, we create a user for linky_exporter. The default shell is false. It can be overwritten to any valid path.

Default value: '/bin/false'

##### `extra_groups`

Data type: `Array[String]`

Add other groups to the managed user.

Default value: []

##### `service_ensure`

Data type: `Variant[Stdlib::Ensure::Service, Enum['absent']]`

State ensured from linky_exporter service.

Default value: 'running'

##### `listen_address`

Data type: `Stdlib::Host`

linky exporter listen address.

Default value: '0.0.0.0'

##### `listen_port`

Data type: `Stdlib::Port`

linky exporter listen port (required to be accessible).

Default value: 9901

##### `serial_device`

Data type: `Stdlib::Absolutepath`

linky serial device.

Default value: '/dev/serial0'

##### `baud_rate`

Data type: `Integer`

linky baud rate.

Default value: 1200

### linky_exporter::install

This class install linky exporter requirements and binaries.

#### Examples

##### 

```puppet
include linky_exporter::install
```

#### Parameters

The following parameters are available in the `linky_exporter::install` class.

##### `version`

Data type: `String`

linky exporter release. See https://github.com/anclrii/linky-Exporter/releases

Default value: $linky_exporter::version

##### `os`

Data type: `String`

Operating system.

Default value: $linky_exporter::os

##### `arch`

Data type: `String`

Architecture.

Default value: $linky_exporter::real_arch

##### `base_dir`

Data type: `Stdlib::Absolutepath`

Base directory where linky is extracted.

Default value: $linky_exporter::base_dir

##### `bin_dir`

Data type: `Stdlib::Absolutepath`

Directory where binaries are located.

Default value: $linky_exporter::bin_dir

##### `download_url`

Data type: `Stdlib::HTTPUrl`

Complete URL corresponding to the linky exporter release, default to undef.

Default value: $linky_exporter::real_download_url

##### `extract_command`

Data type: `Optional[String]`

Custom command passed to the archive resource to extract the downloaded archive.

Default value: $linky_exporter::extract_command

##### `manage_user`

Data type: `Boolean`

Whether to create user for linky_exporter or rely on external code for that.

Default value: $linky_exporter::manage_user

##### `manage_group`

Data type: `Boolean`

Whether to create user for linky_exporter or rely on external code for that.

Default value: $linky_exporter::manage_group

##### `user`

Data type: `String`

User running linky_exporter.

Default value: $linky_exporter::user

##### `group`

Data type: `String`

Group under which linky_exporter is running.

Default value: $linky_exporter::group

##### `user_shell`

Data type: `Stdlib::Absolutepath`

if requested, we create a user for linky_exporter. The default shell is false. It can be overwritten to any valid path.

Default value: $linky_exporter::user_shell

##### `extra_groups`

Data type: `Array[String]`

Add other groups to the managed user.

Default value: $linky_exporter::extra_groups

### linky_exporter::service

This class manages service

#### Examples

##### 

```puppet
include linky_exporter::service
```

#### Parameters

The following parameters are available in the `linky_exporter::service` class.

##### `ensure`

Data type: `Variant[Stdlib::Ensure::Service, Enum['absent']]`

State ensured from linky_exporter service.

Default value: $linky_exporter::service_ensure

##### `user`

Data type: `String`

User running linky_exporter.

Default value: $linky_exporter::user

##### `group`

Data type: `String`

Group under which linky_exporter is running.

Default value: $linky_exporter::group

##### `listen_address`

Data type: `Stdlib::Host`

linky exporter listem address (required to be accessible).

Default value: $linky_exporter::listen_address

##### `listen_port`

Data type: `Stdlib::Port`

linky exporter listen port (required to be accessible).

Default value: $linky_exporter::listen_port

##### `serial_device`

Data type: `Stdlib::Absolutepath`

linky serial device.

Default value: $linky_exporter::serial_device

##### `baud_rate`

Data type: `Integer`

linky baud rate.

Default value: $linky_exporter::baud_rate

##### `bin_dir`

Data type: `Stdlib::Absolutepath`

Directory where binaries are located.

Default value: $linky_exporter::bin_dir

